#include <stdio.h>     
#include <stdlib.h>
#include <stdbool.h>
#include "sudoku.h"


/* Dans ce main, on affiche le sudoku à résoudre, et
   l'utilisateur·rice essaie de le résoudre interactivement en donnant
   x, y et une valeur, tant qu'il ne reste pas de case vide.
   On passe sudoku1 en paramètre de chacune des fonctions.
*/
int main()
{
  // Nous vous fournissons un sudoku à résoudre.
  sudoku sudoku1 = {
    { 0, 9, 4, 2, 0, 6, 0 , 0, 0 },
    { 0,0, 0, 0, 0, 4, 0, 1, 0 },
    { 7, 8, 0, 3, 0, 0, 2, 0, 0 },
    { 0, 4, 3, 0, 7, 5, 1, 8, 2 },
    { 8, 5, 6, 0, 3, 2, 9, 0, 4 },
    {0, 0, 0, 0, 9, 8, 0, 6, 0 },
    {0, 0, 7, 8, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 3, 4, 0, 7},
    {4, 6, 0, 0, 0, 0, 0, 3, 1}
  };
  
  // Solution du sudoku1 - 
  /*
    3 9 4 2 1 6 7 5 8 
    6 2 5 7 8 4 3 1 9 
    7 8 1 3 5 9 2 4 6 
    9 4 3 6 7 5 1 8 2 
    8 5 6 1 3 2 9 7 4 
    1 7 2 4 9 8 5 6 3 
    2 3 7 8 4 1 6 9 5 
    5 1 8 9 6 3 4 2 7 
    4 6 9 5 2 7 8 3 1
  */


  // TODO : implémenter l'interaction avec l'utilisateur·rice
  // pour réaliser le jeu interactif.
  // Attention, la fonction lireAction a pour effet de bord de modifier les variables globales entreeX,entreeY,entreeV
  // La résolution est en bonus
  // 
  // BEGIN CUT
  
  int nb_libres=compterLibres(sudoku1);
  int res;

  bool interactif = true; // changer ici pour la resolution
  
  if (interactif){
    
    while (nb_libres !=0 ){
      afficherSudoku(sudoku1);
      res = lireAction();
      if (res){//lecture avec succès
	if (estValide(sudoku1, entreeX, entreeY, entreeV)){
	  sudoku1[entreeX][entreeY]=entreeV;
	  printf("sudoku modifié!");	
	  nb_libres --;
	}
	else {
	  printf("non valide (contraintes sudoku)\n");
	}
      }
      else {
	printf("valeurs non conformes\n");
      }
    }
  }
  else {
    resoudreSudoku(sudoku1);
  }
  
  printf("il semblerait que le sudoku soit résolu, bravo!\n");
  afficherSudoku(sudoku1);
  // END CUT
  return 0;
}
