#include <stdio.h>     
#include <stdlib.h>
#include <stdbool.h>     
#include <string.h>
#include "sudoku.h" 

// variables globales.
int entreeX, entreeY, entreeV;

void afficherSudoku(sudoku s) 
{    
  //BEGIN CUT
  int	   i,j; 
  //  printf(" \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"); 
  printf("\n\n0 1 2 3 4 5 6 7 8\n-+-+-+-+-+-+-+-+-\n"); 
  
  for (i=0;i<9;i++) {
    for (j=0;j<9;j++) {
      if (s[i][j]) printf("%d ",s[i][j]); else printf(". ");   
    }
    printf("\n"); 
  }
  //END CUT
  // TODO: à implémenter
}

bool estValideH(sudoku s, int x, int y, int n)
{
  // BEGIN CUT
  int i=0; 
  while ((i<9) && s[x][i]!=n) {
    i++; 
  }
  return (i==9); 
  //END CUT

  // UNCOMMENT return false;
  
}

bool estValideV(sudoku s, int x, int y, int n)
{
  //BEGIN CUT
  int i=0; 
  while ((i<9) && (s[i][y]!=n)) {
    i++; 
  }
  return (i==9); 
  
  // END CUT
  // UNCOMMENT return false;
  
}


bool estValideR(sudoku s, int x, int y, int n)
{
 
  // BEGIN CUT
  int i,j; 
  bool res=true;
  
  for (i=3*(x/3);i<3+3*(x/3);i++) {
    for (j=3*(y/3);j<3+3*(y/3);j++) {
      if (s[i][j]==n) res=false; 
    }
  }
  return res; 
  //END CUT
  

  // UNCOMMENT return false;
  
}


// case 0
bool estValide(sudoku s, int x, int y, int n)
{

  // BEGIN CUT
  if ( s[x][y] != 0 ) return 0 ; 
  return (estValideH(s,x,y,n) && estValideV(s,x,y,n) && estValideR(s,x,y,n));
  // END CUT
  // UNCOMMENT return false;
}


int compterLibres(sudoku s)
{
  // BEGIN CUT
  int i,j,libres=0; 
  for (i=0;i<9;i++) {
    for (j=0;j<9;j++) {
      if(s[i][j]==0) libres++;  
    }
  }
  return libres;
  // END CUT

  // UNCOMMENT return 42;
}


int resoudreSudoku(sudoku s) 
{
  // TODO: à implémenter - (BONUS)
  // BEGIN CUT
  // Version de QG juill22
  int x,y,test; 
  
  // Plusieurs reponses possible de trouveMin: 
  // 1 - le sudoku est fini. 
  // 0 - il reste au moins une case libre 
  // 	Si oui, s'il reste 0 possibilité, le sudoku n'est pas réalisable. 
  if (compterLibres(s) == 0 ) return 1; 
  // not optimized !!!
  for (int i=0;i<9;i++) {
    for (int j=0;j<9;j++) {
      if(s[i][j]==0) { x=i; y=j; }  
    }
  }
  
  // on teste différentes hypothèses sur cette case pour voir si le sudoku peut être gagné. 
  for (test=1;test<10;test++) {
    if (estValide(s,x,y,test) == 1 ) {
      // hypothese a tester 
      //	printf("Hypothese %d in %d,%d\n",test,x,y); 
      s[x][y]=test; 
      //	afficherSudoku(s);
      if (resoudreSudoku(s)==1) return 1; 
      // l'hypothese n'est pas bonne ... On backtrack.  
      s[x][y]=0; 
      //	printf("backtrack Hypothese %d in %d,%d\n",test,x,y); 
    } 	
  }
  // on a rien trouvé....impasse....
  // END CUT
  
  return 0; 
  
}


bool lireAction()
{
  printf("Quelle case voulez-vous modifier?\n");
  printf("ligne=?");
  scanf("%d",&entreeY);
  printf("colonne=?");
  scanf("%d",&entreeY);
  printf("valeur=?");
  scanf("%d",&entreeV);

  // je garde un peu plus que nécessaire
  if (entreeX <0 || entreeX > 8 || entreeY <0 || entreeY > 8
      || entreeV <0 || entreeV >8){
    printf("demande d'action invalide (on sort des bornes)");
    return false;
  }
  
  return true;
}


